#DEFINE	mkCRLF	chr(13)+chr(10)

FUNCTION SetEnvironment(pcBase, plSetDefaultDir)		&& jmeno programu, Setdefault to ProgramDir
LOCAL xcHomeDir, xcBase, xdStichTag, xcTmpFile, xnH, xcLine, xdDatum, xcPath

WITH _SCREEN		&& hlavni okno
	.Visible=.F.		&& schovane
	.Closable=.F.		&& VFP nejde odstrelit
ENDWITH

*****	Nastavovane ji existujc globalni promenne
*	cLogFile	jmeno protokolu
*	cIniFile	jmeno INI souboru
*	cCfgFile	jmeno konfiguracniho souboru
*	cHelpFile	jmeno souboru napovedy
*	cDSN		DSN pro ODBC
*	cPassword	Password
*	cLogin		Username
*	cDataDir	jmeno adresare pro data
* aErrTrap	pole akc pro een chybovch stav

set console OFF
set talk OFF						&& not saved standard SETtings
set near ON
set exact OFF
set exclusive OFF
set century ON
set hours to 24
set safety OFF
set status OFF
set date to GERMAN
set null OFF
set multilocks ON
* set deleted ON
set reprocess to 5 seconds

IF empty(pcBase)
	pcBase=Program(0)
ENDIF

If empty(plSetDefaultDir).or.plSetDefaultDir			&& standard .T.
	set default to (JustPath(sys(16, 0)))
EndIf

public array aErrTrap[1, 2]		&& pole specialne osetrenych chyb
aErrTrap[1, 1]=1707		&& CDX not found
aErrTrap[1, 2]=[RETRY]

ON ERROR do ErrTrap with Error(), Message(), LineNo(), Message(1), Program(), "&pcBase."+".ERL", aErrTrap
ON ESCAPE do MyEscape with "", "&pcBase.", LineNo(), sys(16)

xcHomeDir=Home(0)		&& HomeDir of Program
xcBase=xcHomeDir+pcBase

IF empty(cIniFile)		&& nastavit jen pro dosud nenastavenou hodnotu
	cIniFile=iif(empty(GetEnv("INIFILE")), pcBase+".ini", DefaultExt(GetEnv("INIFILE"), "ini") )
	cINIfile=iif( file(cINIfile), FullPath(cINIfile), ForcePath(cINIfile, JustPath(sys(16, 0))) )
ENDIF

*****	Global-INI-Params read

***	zpracovani LOGFILE
*	nLogFileExpireDays uz musi existovat
IF vartype(nLogFileExpireDays) <> [N]
	release nLogFileExpireDays
	public nLogFileExpireDays
	nLogFileExpireDays=60
ENDIF
nLogFileExpireDays=val(GetIniPar(cIniFile, [LogFileExpireDays], [Common], Transform(nLogFileExpireDays)))
cLogFile=GetIniPar(cIniFile, "LOGFILE", "Common")
IF .not.InList( Upper(cLogFile), ".F.", "F", "0", "NO", "FALSE", "NEIN", "N", "NE")		
	cLogFile=FullPath(iif(Empty(cLogFile), iif(empty(GetEnv("LOGFILE")), pcBase+".log", GetEnv("LOGFILE") ), cLogFile))
	IF (nLogFileExpireDays > 0)		&& kontrola
		If file(cLogFile)			&& zrusim stare zaznamy, jsou-li jake
			xdStichTag=date()-nLogFileExpireDays
			xcTmpFile=FullPath(sys(3)+[.log])
			StrToFile([], xcTmpFile, .F.)		&& existujici prazdny soubor
			xnH=FOpen(cLogFile)
			xcLine=FGets(xnH)		&& 1. dek logfile
			xdDatum=CtoD(left(xcLine,10))
			If xdDatum >= xdStichTag	&& ani nejstar dek nen jet dost star, nic nedlm
				FClose(xnH)
				erase (xcTmpFile)		
			else
				Do while .not.FEof(xnH)
					xcLine=FGets(xnH)
					xdDatum=CtoD(left(xcLine,10))
					If xdDatum >= xdStichTag
						StrToFile(xcLine+mkCRLF, xcTmpFile, .T.)
					EndIf
				EndDo
				FClose(xnH)
				erase (cLogFile)
				rename (xcTmpFile) to (cLogFile)
*				copy file (xcTmpFile) to (cLogFile)
*				erase (xcTmpFile)		
			endif
		EndIf
	ELSE		&& vymazat a zacit znovu
		erase (cLogFile)
	ENDIF
ELSE
	cLogFile=[]
ENDIF

***	CFGFILE
cCfgFile=GetIniPar(cIniFile, "CFGFILE", "Common")
cCfgFile=Iif(Empty(cCfgFile), iif(empty(GetEnv("CFGFILE")), pcBase+".cfg", DefaultExt(GetEnv("CFGFILE"), "cfg") ), cCfgFile)

cHelpFile=GetIniPar(cIniFile, "HELPFILE", "Common")
cHelpFile=Iif(Empty(cHelpFile), iif(empty(GetEnv("HELPFILE")), pcBase+"H.dbf", GetEnv("HELPFILE") ), cHelpFile)

cDSN=GetIniPar(cIniFile, "DSN", "Common")
cDSN=iif(empty(cDSN), GetEnv("DSN"), cDSN )      && ODBC-DataSourceName

cPassword=GetIniPar(cIniFile, "Password", "Common")
cLogin=GetIniPar(cIniFile, "Login", "Common")

cDataDir=GetIniPar(cIniFile, "LOCALDAT", "Common")
cDataDir=iif(empty(cDataDir), GetEnv("LOCALDAT"), cDataDir) && Directory of local tables
cDataDir=AddBs(iif(empty(cDataDir), sys(5)+sys(2003), cDataDir)) && default directory of local tables

CreateINIfile(cIniFile, pcBase)	&& creates INI file, if does not exist

xcPath=xcHomeDir+";"+cDataDir+";"+Set("PATH")
set PATH to (xcPath)

if file (pcBase+"R.dbf")
	set RESOURCE to (pcBase+"R.dbf")
	set RESOURCE ON
else
	set RESOURCE OFF
endif

if file(cHelpFile)		&& setting HELP falls gibt's
	set help to (cHelpFile)
	set help ON
*	on key label F1 do myHelp with "Help", gnHelpContextId
	on key label F1 do myHelp with "Help"
	on key label Shift-F1 do myHelp with "Print", 0
	on key label Ctrl-F1 do myHelp with "Edit", 0
else
	set HELP off
endif

RETURN .T.